# Ipopt::IterativePardisoSolverInterface Class Reference

Interface to the linear solver Pardiso, derived from SparseSymLinearSolverInterface. More...

`#include <IpIterativePardisoSolverInterface.hpp>`

Inheritance diagram for Ipopt::IterativePardisoSolverInterface:
[legend]

List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| IterativePardisoSolverInterface (IterativeSolverTerminationTester &normal_tester, IterativeSolverTerminationTester &pd_tester)
| Constructor.
virtual | ~IterativePardisoSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *ia, const Index *ja)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements are to be stored.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *ia, const Index *ja, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
## Private Member Functions
InexactData & | InexData ()
| Method to easily access Inexact data.
InexactCq & | InexCq ()
| Method to easily access Inexact calculated quantities.
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| IterativePardisoSolverInterface ()
| Default Constructor.
| IterativePardisoSolverInterface (const IterativePardisoSolverInterface &)
| Copy Constructor.
void | operator= (const IterativePardisoSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization (const Index *ia, const Index *ja)
| Call Pardiso to do the analysis phase.
ESymSolverStatus | Factorization (const Index *ia, const Index *ja, bool check_NegEVals, Index numberOfNegEVals)
| Call Pardiso to factorize the Matrix.
ESymSolverStatus | Solve (const Index *ia, const Index *ja, Index nrhs, double *rhs_vals)
| Call Pardiso to do the Solve.
## Private Attributes
Number | decr_factor_
| Decrease factor for dropping tolerances.
SmartPtr < IterativeSolverTerminationTester > | normal_tester_
| Termination tester for normal step computation.
SmartPtr < IterativeSolverTerminationTester > | pd_tester_
| Termination tester for primal-dual step computation.
Information about the matrix
Index | dim_
| Number of rows and columns of the matrix.
Index | nonzeros_
| Number of nonzeros of the matrix in triplet representation.
double * | a_
| Array for storing the values of the matrix.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
Solver specific information
void ** | PT_
| Internal data address pointers.
ipfint | MAXFCT_
| Maximal number of factors with identical nonzero structure.
ipfint | MNUM_
| Actual matrix for the solution phase.
ipfint | MTYPE_
| Matrix type; real and symmetric indefinite.
ipfint * | IPARM_
| Parameter and info array for Pardiso.
double * | DPARM_
| Parameter and info array for Pardiso.
ipfint | MSGLVL_
| Message level.
Some counters for debugging
Index | debug_last_iter_
Index | debug_cnt_
## Solver specific options
enum | PardisoMatchingStrategy { COMPLETE, COMPLETE2x2, CONSTRAINT }
| Type for mathcing strategies. More...
PardisoMatchingStrategy | match_strat_
| Option that controls the matching strategy.
bool | have_symbolic_factorization_
| Flag indicating if symbolic factorization has already been performed.
bool | pardiso_redo_symbolic_fact_only_if_inertia_wrong_
| Flag indicating whether the symbolic factorization should only be done after perturbed elements, if the inertia was wrong.
bool | pardiso_repeated_perturbation_means_singular_
| Flag indicating whether repeated perturbed elements even after a new symbolic factorization should be interpreted as a singular matrix.
bool | skip_inertia_check_
| Flag indicating if the interia is always assumed to be correct.
Index | pardiso_max_droptol_corrections_
| Maximal number of decreases of drop tolerance during one solve.
Index | pardiso_max_iter_
| Options for the preconditioner.
Number | pardiso_iter_relative_tol_
Index | pardiso_iter_coarse_size_
Index | pardiso_iter_max_levels_
Number | pardiso_iter_dropping_factor_
Number | pardiso_iter_dropping_schur_
Index | pardiso_iter_max_row_fill_
Number | pardiso_iter_inverse_norm_factor_
Index | normal_pardiso_max_iter_
Number | normal_pardiso_iter_relative_tol_
Index | normal_pardiso_iter_coarse_size_
Index | normal_pardiso_iter_max_levels_
Number | normal_pardiso_iter_dropping_factor_
Number | normal_pardiso_iter_dropping_schur_
Index | normal_pardiso_iter_max_row_fill_
Number | normal_pardiso_iter_inverse_norm_factor_
Number | pardiso_iter_dropping_factor_used_
| Actualy used dropping tolerances.
Number | pardiso_iter_dropping_schur_used_
Number | normal_pardiso_iter_dropping_factor_used_
Number | normal_pardiso_iter_dropping_schur_used_
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.

## Detailed Description

Interface to the linear solver Pardiso, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 25 of file IpIterativePardisoSolverInterface.hpp.

## Member Enumeration Documentation

enum Ipopt::IterativePardisoSolverInterface::PardisoMatchingStrategy`[private]`

Type for mathcing strategies.

Enumerator:

  COMPLETE |
  COMPLETE2x2 |
  CONSTRAINT |

Definition at line 136 of file IpIterativePardisoSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::IterativePardisoSolverInterface::IterativePardisoSolverInterface | ( | IterativeSolverTerminationTester & | normal_tester,
|  | IterativeSolverTerminationTester & | pd_tester |
| ) |  |  |

Constructor.

virtual Ipopt::IterativePardisoSolverInterface::~IterativePardisoSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::IterativePardisoSolverInterface::IterativePardisoSolverInterface | ( |  | ) | `[private]`

Default Constructor.

Ipopt::IterativePardisoSolverInterface::IterativePardisoSolverInterface | ( | const IterativePardisoSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::IterativePardisoSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::IterativePardisoSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::IterativePardisoSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements are to be stored.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::IterativePardisoSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::IterativePardisoSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::IterativePardisoSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::IterativePardisoSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 78 of file IpIterativePardisoSolverInterface.hpp.

EMatrixFormat Ipopt::IterativePardisoSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 85 of file IpIterativePardisoSolverInterface.hpp.

static void Ipopt::IterativePardisoSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::IterativePardisoSolverInterface::operator= | ( | const IterativePardisoSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::AlgorithmStrategyObject.

ESymSolverStatus Ipopt::IterativePardisoSolverInterface::SymbolicFactorization | ( | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[private]`

Call Pardiso to do the analysis phase.

ESymSolverStatus Ipopt::IterativePardisoSolverInterface::Factorization | ( | const Index * | ia,
|  | const Index * | ja,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call Pardiso to factorize the Matrix.

ESymSolverStatus Ipopt::IterativePardisoSolverInterface::Solve | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call Pardiso to do the Solve.

InexactData& Ipopt::IterativePardisoSolverInterface::InexData | ( |  | ) | `[inline, private]`

Method to easily access Inexact data.

Definition at line 248 of file IpIterativePardisoSolverInterface.hpp.

InexactCq& Ipopt::IterativePardisoSolverInterface::InexCq | ( |  | ) | `[inline, private]`

Method to easily access Inexact calculated quantities.

Definition at line 257 of file IpIterativePardisoSolverInterface.hpp.

## Member Data Documentation

Index Ipopt::IterativePardisoSolverInterface::dim_`[private]`

Number of rows and columns of the matrix.

Definition at line 118 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::nonzeros_`[private]`

Number of nonzeros of the matrix in triplet representation.

Definition at line 121 of file IpIterativePardisoSolverInterface.hpp.

double* Ipopt::IterativePardisoSolverInterface::a_`[private]`

Array for storing the values of the matrix.

Definition at line 124 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 130 of file IpIterativePardisoSolverInterface.hpp.

PardisoMatchingStrategy Ipopt::IterativePardisoSolverInterface::match_strat_`[private]`

Option that controls the matching strategy.

Definition at line 143 of file IpIterativePardisoSolverInterface.hpp.

bool Ipopt::IterativePardisoSolverInterface::have_symbolic_factorization_`[private]`

Flag indicating if symbolic factorization has already been performed.

Definition at line 146 of file IpIterativePardisoSolverInterface.hpp.

bool Ipopt::IterativePardisoSolverInterface::pardiso_redo_symbolic_fact_only_if_inertia_wrong_`[private]`

Flag indicating whether the symbolic factorization should only be done after perturbed elements, if the inertia was wrong.

Definition at line 149 of file IpIterativePardisoSolverInterface.hpp.

bool Ipopt::IterativePardisoSolverInterface::pardiso_repeated_perturbation_means_singular_`[private]`

Flag indicating whether repeated perturbed elements even after a new symbolic factorization should be interpreted as a singular matrix.

Definition at line 153 of file IpIterativePardisoSolverInterface.hpp.

bool Ipopt::IterativePardisoSolverInterface::skip_inertia_check_`[private]`

Flag indicating if the interia is always assumed to be correct.

Definition at line 156 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::pardiso_max_droptol_corrections_`[private]`

Maximal number of decreases of drop tolerance during one solve.

Definition at line 158 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::pardiso_max_iter_`[private]`

Options for the preconditioner.

Definition at line 163 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::pardiso_iter_relative_tol_`[private]`

Definition at line 164 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::pardiso_iter_coarse_size_`[private]`

Definition at line 165 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::pardiso_iter_max_levels_`[private]`

Definition at line 166 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::pardiso_iter_dropping_factor_`[private]`

Definition at line 167 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::pardiso_iter_dropping_schur_`[private]`

Definition at line 168 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::pardiso_iter_max_row_fill_`[private]`

Definition at line 169 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::pardiso_iter_inverse_norm_factor_`[private]`

Definition at line 170 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::normal_pardiso_max_iter_`[private]`

Definition at line 172 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_relative_tol_`[private]`

Definition at line 173 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_coarse_size_`[private]`

Definition at line 174 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_max_levels_`[private]`

Definition at line 175 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_dropping_factor_`[private]`

Definition at line 176 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_dropping_schur_`[private]`

Definition at line 177 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_max_row_fill_`[private]`

Definition at line 178 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_inverse_norm_factor_`[private]`

Definition at line 179 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::decr_factor_`[private]`

Decrease factor for dropping tolerances.

Definition at line 183 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::pardiso_iter_dropping_factor_used_`[private]`

Actualy used dropping tolerances.

Definition at line 187 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::pardiso_iter_dropping_schur_used_`[private]`

Definition at line 188 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_dropping_factor_used_`[private]`

Definition at line 189 of file IpIterativePardisoSolverInterface.hpp.

Number Ipopt::IterativePardisoSolverInterface::normal_pardiso_iter_dropping_schur_used_`[private]`

Definition at line 190 of file IpIterativePardisoSolverInterface.hpp.

bool Ipopt::IterativePardisoSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 197 of file IpIterativePardisoSolverInterface.hpp.

void** Ipopt::IterativePardisoSolverInterface::PT_`[private]`

Internal data address pointers.

Definition at line 203 of file IpIterativePardisoSolverInterface.hpp.

ipfint Ipopt::IterativePardisoSolverInterface::MAXFCT_`[private]`

Maximal number of factors with identical nonzero structure.

Here, we only store one factorization. Is always 1.

Definition at line 206 of file IpIterativePardisoSolverInterface.hpp.

ipfint Ipopt::IterativePardisoSolverInterface::MNUM_`[private]`

Actual matrix for the solution phase.

Is always 1.

Definition at line 208 of file IpIterativePardisoSolverInterface.hpp.

ipfint Ipopt::IterativePardisoSolverInterface::MTYPE_`[private]`

Matrix type; real and symmetric indefinite.

Is always -2.

Definition at line 210 of file IpIterativePardisoSolverInterface.hpp.

ipfint* Ipopt::IterativePardisoSolverInterface::IPARM_`[private]`

Parameter and info array for Pardiso.

Definition at line 212 of file IpIterativePardisoSolverInterface.hpp.

double* Ipopt::IterativePardisoSolverInterface::DPARM_`[private]`

Parameter and info array for Pardiso.

Definition at line 214 of file IpIterativePardisoSolverInterface.hpp.

ipfint Ipopt::IterativePardisoSolverInterface::MSGLVL_`[private]`

Message level.

Definition at line 216 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::debug_last_iter_`[private]`

Definition at line 221 of file IpIterativePardisoSolverInterface.hpp.

Index Ipopt::IterativePardisoSolverInterface::debug_cnt_`[private]`

Definition at line 222 of file IpIterativePardisoSolverInterface.hpp.

SmartPtr<IterativeSolverTerminationTester> Ipopt::IterativePardisoSolverInterface::normal_tester_`[private]`

Termination tester for normal step computation.

Definition at line 266 of file IpIterativePardisoSolverInterface.hpp.

SmartPtr<IterativeSolverTerminationTester> Ipopt::IterativePardisoSolverInterface::pd_tester_`[private]`

Termination tester for primal-dual step computation.

Definition at line 269 of file IpIterativePardisoSolverInterface.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/Inexact/IpIterativePardisoSolverInterface.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines